// Client.java 

import java.net.Socket;
import java.io.*;
import java.awt.TextArea;
import java.awt.TextField;

public class Client{
	Socket connessione;
	DataInputStream in;
	DataOutputStream out;
	TextArea msg;
	TextField iniz,fine,name,code;
	int[] camere=new int[7];
	String[] nomi=new String[7];
	boolean[] temp=new boolean[7];
	int stato;
	CApplet app;
	String server,porta,altroServer,altraPorta;
	
	public Client(CApplet app){
		this.msg=app.msgOut;
		this.iniz=app.msgIniz;
		this.fine=app.msgFine;
		this.name=app.msgName;
		this.code=app.msgCode;
		stato=1;
		this.app=app;
	}
	
	protected void connect(String serv,String port)throws Exception{
		try{
			connessione=new Socket(serv,(new Integer(port)).intValue());
		}catch(Exception e){throw new Exception("ERROR - Server not found\n");}
		try{
			in=new DataInputStream(new BufferedInputStream(connessione.getInputStream()));
			out=new DataOutputStream(new BufferedOutputStream(connessione.getOutputStream()));
		}catch(Exception e){throw new Exception("ERROR - Stream IO not opened\n");}
	}	
	
	public int stato(){return stato;}
	
	public void reset(){
		try{
			in.close();
			out.close();
			connessione.close();
			stato=1;
			msg.append("Stato client resettato\n");
		}catch(Exception e){msg.append("ERROR - No reset client state\n");}
	}

	public void set(String s1,String p1,String s2,String p2){
		if(stato==1){
			server=s1;
			porta=p1;
			altroServer=s2;
			altraPorta=p2;
			msg.append("Primo: "+server+" "+porta+"\n");
			msg.append("Secondo: "+altroServer+" "+altraPorta+"\n");
		}
	}

	protected void riceviTabella() throws Exception{
		for(int i=0;i<7;i++){
			camere[i]=in.readInt();
			nomi[i]=in.readUTF();
			temp[i]=in.readBoolean();
		}
		msg.append("--------	--------------------------\n");
		msg.append("giorno	prenotato da\n");
		msg.append("--------	--------------------------\n");
		String s;
		for(int i=0;i<7;i++){
			s=i+"	"+nomi[i];
			if(temp[i]) s=s+" (non confermato)";
			msg.append(s+"\n");
		}
		msg.append("--------	--------------------------\n");
		msg.append("Inserisci le date di inizio e fine soggiorno,\n");
		msg.append("nome e codice. Poi premi OK\n");
	}

	public void run(){
		try{
			if(stato==1){			// arriva la tabella
				try{
					msg.append("Connessione a "+server+" "+porta+" ...\n");
					connect(server,porta);
					riceviTabella();
					stato=2;
				}catch(Exception e){
					msg.append("MALFUNZIONAMENTO SERVER\n");
					msg.append("MI RIVOLGO ALL'ALTRO\n");
					try{
						in.close();
						out.close();
						connessione.close();
					}catch(Exception e1){}
					try{
						msg.append("Connessione a "+altroServer+" "+altraPorta+" ...\n");
						connect(altroServer,altraPorta);
						riceviTabella();
						stato=2;
					}catch(Exception e2){
						msg.append("MALFUNZIONAMENTO DI ENTRAMBI I SERVER\n");
						msg.append("IMPOSSIBILE CONTINUARE!\n");
					}
				}
			}else if(stato==2){		// mando i dati
				int inizI=(new Integer(iniz.getText())).intValue();
				int fineI=(new Integer(fine.getText())).intValue();
				String nameS=name.getText();
				String codeS=code.getText();
				out.writeInt(inizI);
				out.writeInt(fineI);
				out.writeUTF(nameS);
				out.writeUTF(codeS);
				out.flush();
				msg.append("In attesa di risposta...\n");
				msg.append("........................\n");
				String s=in.readUTF();
				msg.append("Risultato: "+s+"\n");
				in.close();
				out.close();
				connessione.close();
				stato=1;
			}
		}catch(Exception e){
			msg.append("MALFUNZIONAMENTO SERVER\n");
			msg.append("MI RIVOLGO ALL'ALTRO\n");
			try{
				in.close();
				out.close();
				connessione.close();
			}catch(Exception e1){}
			try{
				msg.append("Connessione a "+altroServer+" "+altraPorta+" ...\n");
				connect(altroServer,altraPorta);
				riceviTabella();
				msg.append("Se la prenotazione ha avuto successo premi Cancel\n");
				msg.append("Se la prenotazione  'non confermata' aspetta e riprova\n");
				stato=2;
			}catch(Exception e2){
				msg.append("MALFUNZIONAMENTO DI ENTRAMBI I SERVER\n");
				msg.append("IMPOSSIBILE CONTINUARE!\n");
				msg.append(e2+"\n");
			}
		}
	}

}
