/* COORDINAZIONE.JAVA */

import java.awt.*;
import java.lang.Thread;
import java.net.*;
import java.io.*;

public class Coordinazione extends Thread{
	SApplet app;
	ServerSocket ricez;
	Socket ricez1,invio;
	TextArea msg;
	DataInputStream in;
	DataOutputStream out;
	Tabella camere;
	
	public Coordinazione(SApplet app,Tabella camere){
		this.app=app;
		this.msg=app.msgOut;
		this.camere=camere;
		camere.dueServer(true);
	}

	public void connect(String port1,String serv2,String port2){
		try{
			ricez=new ServerSocket((new Integer(port1)).intValue());
			msg.append("Socket ricezione dall'altro server ok\n");
			try{
				invio=new Socket(serv2,(new Integer(port2)).intValue());
				msg.append("Socket invio dall'altro server ok\n");
				in=new DataInputStream(new BufferedInputStream(invio.getInputStream()));
				out=new DataOutputStream(new BufferedOutputStream(invio.getOutputStream()));
				out.writeUTF("Start");
				out.flush();
				String str=in.readUTF();
				if(str.equals("Ok"))
					msg.append("INIZIALIZZAZIONE CORRETTA\n");
				else if(str.equals("Tab")){
					int[] tab=new int[7];
					String[] n=new String[7];
					boolean[] temp=new boolean[7];
					for(int i=0;i<7;i++){
						tab[i]=in.readInt();
						n[i]=in.readUTF();
						temp[i]=in.readBoolean();
					}
					camere.set(tab,n,temp);
					msg.append("Tabella: "+camere+"\n");
					msg.append("INIZIALIZZAZIONE CORRETTA\n");
				}else{
					msg.append("INIZIALIZZAZIONE NON CORRETTA\n");
					throw new Exception();
				}
			}catch(Exception e){
				camere.dueServer(false);
				msg.append("L'altro server non c' ancora\n");
			}
		}catch(Exception ex){msg.append("ERRORE in inizializzazione\n");}
	}
	
	public void run(){
		gestoreRichiestaServer t;
		int i=0;
		try{
			while(true){
				msg.append("In attesa di richieste server...\n");
				ricez1=ricez.accept();
				t=new gestoreRichiestaServer(ricez1,"ThreadServer"+i,app,camere);
				msg.append("Richiesta ricevuta: ThreadServer"+i+" partito\n");
				i++;
				t.start();
			}
		}catch(Exception e){msg.append("ERROR - "+e+"\n");}
	}

	public void close(){
		try{
			in.close();
			out.close();
			ricez1.close();			
			ricez.close();
			invio.close();
		}catch(Exception e){msg.append("ERROR - Not closed\n");}
	}

}

