// Server.JAVA

import java.awt.*;
import java.lang.Thread;
import java.net.*;
import java.io.*;

public class Server extends Thread{
	SApplet app;
	ServerSocket conn;
	Socket connessione;
	TextArea out;
	Tabella camere;
	Coordinazione coo;
	
	public Server(SApplet app,Tabella camere){
		this.app=app;
		this.out=app.msgOut;
		this.camere=camere;
		coo=new Coordinazione(app,camere);
	}
	
	public void connect(String port){
		out.append("\n");
		out.append("****************************************\n");
		if(camere.master()) out.append("Server Master\n");
		else out.append("Server Slave\n");
		out.append("Inizializzazione del sistema ...\n");
		try{
			coo.connect(app.msgPS.getText(),app.msgS2.getText(),app.msgP2.getText());
			coo.start();
		}catch(Exception ex){out.append(ex+"\n");}
		out.append("****************************************\n");
		out.append("Server attivato!\n");
		out.append("Premere Broke per disattivarlo\n");
		out.append("****************************************");
		out.append("\n");
		try{
			conn=new ServerSocket((new Integer(port)).intValue());
			out.append("Socket ok\n");
		}catch(Exception e){out.append("ERROR - No socket open\n");}
	}
	
	public void run(){
		int i=0;
		try{
			while(true){
				out.append("In attesa di richieste...\n");
				connessione=conn.accept();
				gestoreRichiestaClient t=new gestoreRichiestaClient(connessione,
																													"Thread"+i,app,camere,coo);
				out.append("Richiesta ricevuta: Thread"+i+" partito\n");
				i++;
				t.start();
			}
		}catch(Exception e){out.append("ERROR - "+e+"\n");}
	}

	public void close(){
		try{
			conn.close();
			coo.close();
			coo.stop();
		}catch(Exception e){out.append("ERROR - Not closed\n");}
	}
	
}

