// TABELLA.JAVA	
// gestione della tabella delle prenotazioni e dello stato del server

import java.lang.Thread;

public class Tabella extends Thread{
	int[] camere;				// numero camere libere
	String[] nomi;			// nomi prenotazioni
	boolean[] temp;			// vero se la prenotazione non  ancora definitiva
	boolean modify;			// vero se tabella modificata dai valori iniziali
	// stato server
	boolean master;			// vero se server master, falso se slave
	boolean dueServer;	// vero se c' anche l'altro server e le modifiche vanno coordinate
	String currName,currCode;

	public Tabella(int n){
		camere=new int[7];
		nomi=new String[7];
		temp=new boolean[7];
		for(int i=0;i<7;i++){
			camere[i]=n;
			nomi[i]=".....";
			temp[i]=false;
		}
		// stato iniziale
		modify=false;
		dueServer=true;
		master=false;
	}

	public String toString(){
		String s="[ ";
		for(int i=0;i<7;i++) s=s+i+"("+camere[i]+","+nomi[i]+","+temp[i]+") ";
		s=s+"]";
		return s;
	}

	public int camera(int g){return camere[g];}
	public String nome(int g){return nomi[g];}
	public boolean temp(int g){return temp[g];}

	public boolean modificato(){return modify;}

	public boolean master(){return master;}
	public void master(boolean m){master=m;}
	
	public boolean dueServer(){return dueServer;}
	public void dueServer(boolean d){dueServer=d;}
	
	public void set(int[] c,String[] n,boolean[] t){
		synchronized(this){
			modify=true;
			for(int i=0;i<7;i++){
				camere[i]=c[i];
				nomi[i]=n[i];
				temp[i]=t[i];
			}
		}
	}

	public boolean libero(int iniz,int fin){
		int i;
		if(iniz>fin) return false;
		synchronized(this){
			for(i=iniz;i<=fin;i++) if(camere[i]==0) return false;
		}
		return true;
	}
	
	public boolean prenota(int iniz,int fin,String n){
		int i;
		if(iniz>fin) return false;
		synchronized(this){
			for(i=iniz;i<=fin;i++) if(camere[i]==0) return false;
			modify=true;
			for(i=iniz;i<=fin;i++){
				camere[i]--;
				nomi[i]=n;
				temp[i]=true;
			}
		}
		return true;
	}

	public void conferma(int iniz,int fin){
		int i;
		synchronized(this){
			for(i=iniz;i<=fin;i++)
				temp[i]=false;
		}
	}

	public boolean resume(int iniz,int fin,String s){
		int i;
		synchronized(this){
			for(i=iniz;i<=fin;i++) if(!(nomi[i].equals(s))) return false;
			for(i=iniz;i<=fin;i++){
				camere[i]++;
				nomi[i]=".....";
				temp[i]=false;
			}
		}
		return true;
	}

}
