// gestoreRichiesta.java

import java.awt.*;
import java.lang.Thread;
import java.net.*;
import java.io.*;

public class gestoreRichiesta extends Thread{
	Socket s;
	DataInputStream in;
	DataOutputStream out;
	TextArea msg;
	Tabella conti;
	BApplet app;
	boolean first;
	
	public gestoreRichiesta(Socket s,String nome,BApplet app,Tabella conti){
		super(nome);
		this.s=s;
		this.msg=app.msgOut;
		this.conti=conti;
		this.app=app;
	}

	public void run(){
		String nome=Thread.currentThread().getName();
		try{
			in=new DataInputStream(new BufferedInputStream(s.getInputStream()));
			out=new DataOutputStream(new BufferedOutputStream(s.getOutputStream()));
			int m=in.readInt();
			if(m==1) first=true;
			else if(m==2) first=false;
			else throw new Exception();
			String name=in.readUTF();
			String code=in.readUTF();
			int val=in.readInt();
			int iniz=in.readInt();
			int fine=in.readInt();
			msg.append("Transazione: "+name+" "+code+", di "+val+" euro\n");
			msg.append("per prenotazione dal "+iniz+" al "+fine+"\n");
			if(first){	// prima richiesta
				if(conti.transazione(name,code,val,iniz)){
					msg.append("Transazione effettuata\n");
					try{
						out.writeUTF("Ok");
						out.flush();
					}catch(Exception e1){msg.append("Server caduto! Tutto ok!\n");}
				}else{
					msg.append("Transazione non effettuabile!\n");
					msg.append("Mando ordine di Undo\n");
					try{
						out.writeUTF("No");
						out.flush();
						String u=in.readUTF();
						if(u.equals("Ok")){
							msg.append("Undo completato\n");
						}else{
							throw new Exception();
						}
					}catch(Exception ex){
						msg.append("Malfunzionamento durante Undo\n");
					}
				}
			}else{		// seconda richiesta
				if(conti.transazioneGiFatta(name,code,iniz)){
					msg.append("La transazione  gi stata effettuata\n");
					msg.append("ed ha avuto successo\n");
					out.writeUTF("Ok");
					out.flush();
				}else if(conti.transazione(name,code,val,iniz)){
					msg.append("Transazione effettuata\n");
					try{
						out.writeUTF("Ok");
						out.flush();
					}catch(Exception e1){msg.append("Server caduto!\n");}
				}else{
					msg.append("Transazione non effettuabile!\n");
					msg.append("Mando ordine di Undo\n");
					try{
						out.writeUTF("No");
						out.flush();
						String u=in.readUTF();
						if(u.equals("Ok")){
							msg.append("Undo completato\n");
						}else{
							throw new Exception();
						}
					}catch(Exception ex){
						msg.append("Malfunzionamento durante Undo\n");
					}
				}
			}
		}catch(Exception e){msg.append(nome+" ERROR - Not data flow\n");}
		msg.append("Tabella: "+conti+"\n");
		try{
			in.close();
			out.close();
			s.close();
		}catch(Exception e){msg.append(nome+" ERROR - Socket not closed\n");}
	}
	
}
