// gestoreRichiestaClient.java

import java.awt.*;
import java.lang.Thread;
import java.net.*;
import java.io.*;

public class gestoreRichiestaClient extends Thread{
	Socket s;
	DataInputStream in;
	DataOutputStream out;
	TextArea msg;
	Tabella camere;
	SApplet app;
	Coordinazione coo;
	
	public gestoreRichiestaClient(Socket s,String nome,SApplet app,Tabella camere,
																Coordinazione coo){
		super(nome);
		this.s=s;
		this.msg=app.msgOut;
		this.camere=camere;
		this.app=app;
		this.coo=coo;
	}

	public void run(){
		String nome=Thread.currentThread().getName();
		boolean riuscito=false;
		try{
			in=new DataInputStream(new BufferedInputStream(s.getInputStream()));
			out=new DataOutputStream(new BufferedOutputStream(s.getOutputStream()));
			for(int i=0;i<7;i++){
				out.writeInt(camere.camera(i));
				out.writeUTF(camere.nome(i));
				out.writeBoolean(camere.temp(i));
			}
			out.flush();
			int inizI,fineI;
			inizI=in.readInt();
			fineI=in.readInt();
			String nameS=in.readUTF();
			String codeS=in.readUTF();
			camere.currName=nameS;
			camere.currCode=codeS;
			msg.append("Nome: "+nameS+" code: "+codeS+"\n");
			msg.append("richiede prenotazione dal "+inizI+" al "+fineI+"\n");
			invioRichiestaServer t;
			t=new invioRichiestaServer(nome+"S",app,camere,inizI,fineI,nameS,codeS);
			if(camere.dueServer()){	// caso in cui ci sono entrambi i server
				if(camere.master()){	// server master
					msg.append("Master Server\n");
					if(!(camere.prenota(inizI,fineI,nameS))){
						msg.append("Prenotazione fallita localmente\n");
						out.writeUTF("Prenotazione fallita");
					}else{
						t.connect(app.msgS2.getText(),app.msgP2.getText());
						if(!(camere.dueServer())){
							msg.append("L'altro server  caduto!\n");
							msg.append("Continuo da solo\n");
							msg.append("Prenotazione effettuata\n");
							riuscito=true;
						}else{
							t.start();
							t.join();
							if(t.getStato()){
								msg.append("Prenotazione effettuata\n");
								riuscito=true;
							}else{
								msg.append("Prenotazione fallita non localmente\n");
								msg.append("MALFUNZIONAMENTO: ARRESTARE IL SISTEMA!\n");
								msg.append("(LA RICHIESTA DEL SERVER MASTER E' STATA RIFIUTATA)\n");
								out.writeUTF("Prenotazione fallita");
							}
						}
					}
				}else{								// server slave
					msg.append("Slave Server\n");
					if(!(camere.libero(inizI,fineI))){
						msg.append("Prenotazione fallita localmente\n");
						out.writeUTF("Prenotazione fallita");
					}else{
						t.connect(app.msgS2.getText(),app.msgP2.getText());
						if(camere.dueServer()){
							t.start();
							t.join();
						}else{
							msg.append("L'altro server  caduto!\n");
							msg.append("Continuo da solo\n");
						}
						if((t.getStato())||(!(camere.dueServer()))){ // se ok dal server o se non c'
							if(camere.prenota(inizI,fineI,nameS)){
								msg.append("Prenotazione effettuata\n");
								riuscito=true;
							}else{
								msg.append("Prenotazione fallita localmente\n");
								out.writeUTF("Prenotazione fallita");
							}
						}else{	// se l'altro server non da dato ok
							msg.append("Prenotazione fallita non localmente\n");
							out.writeUTF("Prenotazione fallita");
						}
					}
				}
			}else{			// caso in cui l'altro server non c'
				if(camere.prenota(inizI,fineI,nameS)){
					msg.append("Prenotazione effettuata\n");
					riuscito=true;
				}else{
					msg.append("Prenotazione fallita localmente\n");
					out.writeUTF("Prenotazione fallita");
				}
			}
			out.flush();
			if(riuscito){		// chiede conferma alla banca
				int val=50;
				invioRichiestaBanca b;
				b=new invioRichiestaBanca(nome+"B",app,nameS,codeS,val,inizI,fineI,camere,true);
				msg.append("Collegamento alla banca ...\n");
				b.connect(app.msgB.getText(),app.msgPB.getText());
				b.start();
				b.join();
				if(b.getStato()){					// la banca dice ok
					camere.conferma(inizI,fineI);									// do l'ok localmente
					out.writeUTF("Prenotazione effettuata\n");		// do l'ok al client
					out.flush();
					t.closeOk();							// do l'ok alla'altro server
				}else{
					out.writeUTF("Prenotazione bloccata dalla banca");
					out.flush();
					b.sendOk();		// dico alla banca che  ok
					b.close();		
					if(!(camere.master()))		// slave: aggiorna subito
						camere.resume(inizI,fineI,nameS);
					if(camere.dueServer()){		// se in 2 --> undo anche all'altro
						t.closeUndo();					// do l'undo all'altro server
						if(!(camere.dueServer())){
							msg.append("L'altro server  caduto!\n");
							msg.append("Continuo da solo\n");
						}
					}
					if(camere.master())		// master: aggiorna dopo
						camere.resume(inizI,fineI,nameS);
				}
			}
			msg.append("Tabella: "+camere+"\n");
		}catch(Exception e){msg.append(nome+" ERROR - Not data flow\n");}
		try{
			in.close();
			out.close();
			s.close();
		}catch(Exception e){msg.append(nome+" ERROR - Socket not closed\n");}
	}
	
}
