// gestoreRichiestaServer.java

import java.awt.*;
import java.lang.Thread;
import java.net.*;
import java.io.*;

public class gestoreRichiestaServer extends Thread{
	Socket s;
	DataInputStream in;
	DataOutputStream out;
	TextArea msg;
	Tabella camere;
	String nome;
	SApplet app;
	
	public gestoreRichiestaServer(Socket s,String nome,SApplet app,Tabella camere){
		super(nome);
		this.s=s;
		this.msg=app.msgOut;
		this.camere=camere;
		this.nome=nome;
		this.app=app;	
	}

	public void run(){
		try{
			in=new DataInputStream(new BufferedInputStream(s.getInputStream()));
			out=new DataOutputStream(new BufferedOutputStream(s.getOutputStream()));
			camere.dueServer(true);
			String str=in.readUTF();
			if(str.equals("Start")){		// richiesta di inizializzazione
				msg.append("L'altro server ha iniziato\n");
				if(camere.modificato()){
					out.writeUTF("Tab");
					msg.append("Gli mando la tabella\n");
					for(int i=0;i<7;i++){
						out.writeInt(camere.camera(i));
						out.writeUTF(camere.nome(i));
						out.writeBoolean(camere.temp(i));
					}
					out.flush();
				}else{
					out.writeUTF("Ok");
					out.flush();
				}
			}else if(str.equals("Change")){	// richiesta di cambiamento tabella
				if(!(camere.dueServer())){
					msg.append("MALFUNZIONAMENTO: ARRESTARE IL SISTEMA!\n");
					msg.append("(TABELLA INCONSISTENTE)\n");
					out.writeUTF("Halt");
					out.flush();
				}
				int iniz=in.readInt();
				int fine=in.readInt();
				String n=in.readUTF();
				String cod=in.readUTF();
				if(camere.prenota(iniz,fine,n)){
					msg.append("Richiesta dell'altro server accettata\n");
					try{
						out.writeUTF("Ok");
						out.flush();
						msg.append("Tabella: "+camere+"\n");
						String s=in.readUTF();
						if(s.equals("Ok")){			// se ok banca
							camere.conferma(iniz,fine);
							msg.append("Ricevuta conferma dalla'altro server\n");
							msg.append("dopo l'ok della banca\n");
						}else if(s.equals("Undo")){		// se no ok banca
							msg.append("Richiesta di undo\n");
							msg.append("Operazione annullata dala banca\n");
							if(camere.resume(iniz,fine,n))
								msg.append("Undo eseguito\n");
							else msg.append("Undo gi fatto in precedenza\n");
						}else{							// altre richieste
							msg.append("RICHIESTA SERVER NON RICONOSCIUTA1\n");
							msg.append("("+s+")\n");
						}
					}catch(Exception ex1){
						camere.dueServer(false);
						msg.append(nome+" ERROR - L'altro server  caduto\n");
						msg.append(nome+" Non so se la banca  d'accordo\n");
						invioRichiestaBanca b;
						int val=50;
						b=new invioRichiestaBanca(nome+"B",app,n,cod,val,iniz,fine,camere,false);
						msg.append("Collegamento alla banca ...\n");
						b.connect(app.msgB.getText(),app.msgPB.getText());
						b.start();
						b.join();
						if(b.getStato()){					// la banca dice ok
							msg.append("Conferma dalla banca\n");
							camere.conferma(iniz,fine);									// do l'ok localmente
						}else{
							msg.append("Prenotazione bloccata dalla banca");
							b.sendOk();		// dico alla banca che  ok
							b.close();		
							camere.resume(iniz,fine,n);		// undo solo locale, sono da solo
						}
					}
			}else{
					msg.append("Richiesta dell'altro server rifiutata\n");
					out.writeUTF("No");
					out.flush();
					if(!(camere.master())){
						msg.append("MALFUNZIONAMENTO: ARRESTARE IL SISTEMA!\n");
						msg.append("(LA RICHIESTA DEL SERVER MASTER E' STATA RIFIUTATA)\n");
					}
				}
				msg.append("Tabella: "+camere+"\n");
			}else{							// altre richieste
				msg.append("RICHIESTA SERVER NON RICONOSCIUTA2\n");
				out.writeUTF("Halt");
				out.flush();
			}
		}catch(Exception e){
			camere.dueServer(false);
			msg.append(nome+" ERROR - L'altro server  caduto\n");
		}
		try{
			in.close();
			out.close();
			s.close();
		}catch(Exception e){msg.append(nome+" ERROR - Socket not closed\n");}
	}
}	

