// invioRichiestaServer.java

import java.awt.*;
import java.lang.Thread;
import java.net.*;
import java.io.*;

public class invioRichiestaServer extends Thread{
	Socket s;
	DataInputStream in;
	DataOutputStream out;
	TextArea msg;
	Tabella camere;
	int iniz,fine;
	boolean stato;
	String name;		// nome del cliente
	String code;		// codice cliente
	String nome;		// nome del thread

	public invioRichiestaServer(String nome,SApplet app,Tabella camere,int iniz,int fine,
																String name,String code){
		super(nome);
		this.msg=app.msgOut;
		this.camere=camere;
		this.iniz=iniz;
		this.fine=fine;
		stato=false;
		this.name=name;
		this.nome=nome;
		this.code=code;
	}

	public void connect(String serv,String port)throws Exception{
		try{
			s=new Socket(serv,(new Integer(port)).intValue());
			in=new DataInputStream(new BufferedInputStream(s.getInputStream()));
			out=new DataOutputStream(new BufferedOutputStream(s.getOutputStream()));
		}catch(Exception e){
			msg.append("ERROR - Server not found\n");
			camere.dueServer(false);
		}
	}	

	public void run(){
		try{
			out.writeUTF("Change");
			out.writeInt(iniz);
			out.writeInt(fine);
			out.writeUTF(name);
			out.writeUTF(code);
			out.flush();
			String str=in.readUTF();
			if(str.equals("Ok")){
				msg.append("L'altro server dice ok\n");
				stato=true;
			}else if(str.equals("No")){
				msg.append("L'altro server dice no\n");
				stato=false;
			}else if(str.equals("Halt")){
				msg.append("MALFUNZIONAMENTO: ARRESTARE IL SISTEMA!\n");
				msg.append("(TABELLA INCONSISTENTE)\n");
			}else{
				msg.append("Risposta dell'altro server non riconoscita\n");
				stato=false;
			}
		}catch(Exception e){
			msg.append(nome+" ERROR - Not data flow\n");
			stato=false;
		}
	}

	protected void close(){
		try{
			in.close();
			out.close();
			s.close();
		}catch(Exception e){msg.append(nome+" ERROR - Socket not closed\n");}
	}
	
	public void closeOk(){
		try{
			msg.append("Mando ok banca all'altro server\n");
			out.writeUTF("Ok");
			out.flush();
		}catch(Exception e){
			msg.append("ERROR - Server caduto\n");
			camere.dueServer(false);
		}
		close();
	}
	
	public void closeUndo(){
		try{
			msg.append("Mando undo all'altro server\n");
			out.writeUTF("Undo");
			out.flush();
		}catch(Exception e){
			msg.append("ERROR - Server caduto\n");
			camere.dueServer(false);
		}
		close();
	}

	public boolean getStato(){return stato;}

}	

